全面了解java异常

异常的概念

异常,在程序中的意思是:程序在执行过程中,出现的非正常的情况,最终会导致JVM的非正常停止。

Java的异常机制主要依赖于try、catch、finally、throw和throws五个关键字
其中try关键字后面紧跟着一个花括号括起来的代码块,它里面放置可能会引发异常的代码块。catch后面对应异常类型和一个代码块,用于表明该catch块用于处理这种异常类型的代码块,多个catch块后面还可以跟一个finally块,用于回收在try块里打开的物理资源,异常机制会保证finally块一定被执行
throws关键字主要在方法签名中使用,用于声明该方法可能抛出的异常
而throw用于抛出一个实际的异常,throw可以单独作为语句使用,抛出一个具体的异常对象。

在Java等面向对象的编程语言中,异常本身是一个类,产生异常就是创建并抛出了一个异常对象。Java处理异常的方式是中断处理。异常指的并不是语法错误,语法错了编译不能通过,不会产生字节码文件,根本不能运行。

异常体系

全面了解java异常_第1张图片

Error:严重错误Error,无法通过处理的错误,只能事先避免,比如内存溢出。
Exception:表示异常,异常产生后程序员可以通过代码的方式纠正,使程序继续运行,是必须要处理的

异常的分类

我们平常说的异常就是指Exception,因为这类异常一旦出现,我们就要对代码进行更正,修复程序。
异常(Exception)的分类:根据在编译时期还是运行时期去检查异常。
编译时期异常:checked异常。在编译时期就会检查,如果没有处理异常,则编译失败。(如日期格式化异常)运行时期异常:
runtime异常。在运行时期,检查异常。在编译时期,运行期异常不会被编译器检测(不报错)。(如数学异常)

异常产生的过程分析

1.JVM(java virtual machine)会检测出程序出现的异常,JVM会做两件事情。

1).JVM会根据异常产生的原因创建一个异常对象,这个异常对象包含了异常产生的(内容,原因,位置)。
2).在方法中,没有异常处理的逻辑(try-catch),那么JVM就会把异常对象抛出给方法的调用者main方法来处理这个异常.

2.MAIN方法接受到这个异常对象,MAIN方法也没有异常的处理逻辑,继续把对象抛出给MAIN方法的调用者JVM处理(MAIN方法把异常对象抛出给JVM)
3.JVM接受到这个异常对象,做了两件事情。

1).把异常对象(内容,原因,位置)以红色的字体打印在控制台
2).JVM会终止当前正在执行的java程序 à中断处理

异常的处理

Java异常处理的五个关键字:try、catch、finally、throw、throws。

抛出异常throw

在编写程序时,我们必须要考虑程序出现问题的情况。比如,在定义方法时,方法需要接受参数。那么,当调用方法使用接受到的参数时,首先需要先对参数数据进行合法的判断,数据若不合法,就应该告诉调用者,传递合法的数据进来。这时需要使用抛出异常的方式来告诉调用者。

在java中,提供了一个throw关键字,它用来抛出一个指定的异常对象。那么,抛出一个异常具体如何操作呢?
1.创建一个异常对象。封装一些提示信息(信息可以自己编写)。
2.需要将这个异常对象告知给调用者。怎么告知呢?怎么将这个异常对象传递到调用者处呢?通过关键字throw就可以完成。

throw用在方法内,用来抛出一个异常对象,将这个异常对象传递到调用者处,并结束当前方法的执行。

格式

throw new 异常类名(参数);

//例:
public class ThrowDemo{
    public static void main(String[]args){
        //创建一个数组
        int[]arr={9,5,2,7};
        //根据索引找对应元素
        int index = 4; 
        int element = getElement(arr,index); 
  		System.out.println(element);
        System.out.println("over!");
    }
    public static int getElement(int arr[],int index){
        //判断索引是否越界
        if(index<0||index>arr.length-1){
            /*
            *判断条件如果满足,当执行完throw抛出异常对象后,方法已经无法继续运算.
            *这时就会结束当前方法的执行,并将异常告知给调用者,这时就需要通过异常来解决.
            */
            throw new ArrayIndexOutOfBoundsException("哥们,角标越界了!!!"); 
        }
        int element=arr[index];
        return element;
    }
}

注意:如果产生了问题,我们就会throw将问题描述类即异常进行抛出,也就是将问题返回给该方法的调用者
那么对于调用者来说,该怎么处理呢?一种是进行捕获处理,另一种就是继续讲问题声明出去,使用throws声明处理

声明异常throws

声明异常:将问题标识出来,报告给调用者。如果方法内通过throw抛出了编译时异常,而没有捕获处理(稍后讲解该方式),那么必须通过throws进行声明,让调用者去处理
关键字throws运用于方法声明之上,用于表示当前方法不处理异常,而是提醒该方法的调用者来处理异常(抛出异常)

声明异常格式:

修饰符 返回值类型 方法名 (参数列表) throws 异常类名1,异常类名2... {  } 

//示例代码
public class ThrowsDemo{
    public static void main(String[]args) throws FileNotFoundException {
        read("a.txt");
    }
    //定义功能时有问题发生需要报告给调用者.可以通过在方法上使用throws关键字进行声明
  public static void read(String path) throws FileNotFoundException{
      if(!path.equals("a.txt")){
          //如果不是a.txt就认为文件不存在是一个异常抛出问题!
          throw new FileNotFoundException("文件不存在");
      }
  }
}

throws用于进行异常类的声明,若该方法可能有多种异常情况产生,那么在throws后面可以写多个异常类,用逗号隔开。

public class ThrowsDemo2 {
    public static void main(String[]args) throwsIOException {
        read("a.txt");
    }
    //定义功能时有问题发生需要报告给调用者.可以通过在方法上使用throws关键字进行声明
  public static void read(String path) throws FileNotFoundException , IOException {
      if(!path.equals("a.txt")) {
          //如果不是a.txt就认为文件不存在是一个异常抛出问题!
          throw new FileNotFoundException("文件不存在");
      }
      if(!path.equals("b.txt")){
          throw new IOException();
      }
  }
}

捕获异常try…catch

如果异常出现的话,会立刻终止程序,所以我们得处理异常:
1.该方法不处理,而是声明抛出,由该方法的调用者来处理(throws)。
2.在方法中使用try-catch的语句块来处理异常。
try-catch的方式就是捕获异常。
捕获异常:Java中对异常有针对性的语句进行捕获,可以对出现的异常进行指定方式的处理。

捕获异常语法

try {
    编写可能会出现异常的代码
}catch(异常类型 e){
    处理异常的代码
        //记录日志/打印异常信息/继续抛出异常
}

try:该代码块中编写可能产生异常的代码。
catch:用来进行某种异常的捕获,实现对捕获到的异常进行处理。
注意:

try和catch都不能单独使用,必须连用。

try里面还可以有try…catch

示例代码:

public class TryCatchDemo {
    public static void main (String[]args) {
        try {//当产生异常时,必须有处理方式,要么捕获要么声明
            read("a.txt");
        }catch(FileNotFoundException e){//try中抛出什么异常,括号中就定义什么类型
     	 System.out.println(e);
        }
     System.out.println("OVER!");
    }
    //定义功能时有问题发生需要报告给调用者.可以通过在方法上使用throws关键字进行声明
  public static void read (String path) throws FileNotFoundException {
      if(!path.equals("a.txt")){
          //如果不是a.txt就认为文件不存在是一个异常抛出问题!
          throw new FileNotFoundException("文件不存在");
      }
  }
}

如何获取异常信息:

Throwable类中定义了一些查看方法:
public String getMessage():获取异常的描述信息,原因(提示给用户的时候,就提示错误原因。

public String toString():获取异常的类型和异常描述信息(不用)。

public void printStackTrace():打印异常的跟踪栈信息并输出到控制台。包含了异常的类型,异常的原因,还包括异常出现的位置,在开发和调试阶段,都得使用printStackTrace。

示例代码:

public static void main(String[]args){
    try {
        String str=null;
        System.out.println(str.length());
    }catch(Exceptione){
        e.printStackTrace();//打印异常的堆栈追踪信息
    }
    System.out.println("OVER!");
}

//运行结果:
java.lang.NullPointerException
    at com.langsin.exception.ExceptionDemo.main(ExceptionDemo.java:7)
    OVER!

finally代码块

finally:有一些特定的代码无论异常是否发生,都需要执行。另外,因为异常会引发程序跳转,导致有些语句执行不到。而finally就是解决这个问题的,在finally代码块中存放的代码都是一定会被执行的。

什么时候的代码必须最终执行?

当我们在try语句块中打开了一些物理资源(磁盘文件/网络连接/数据库连接等),我们都得在使用完之后,最终关闭打开的资源。

注意:finally不能单独使用。

比如在我们之后学习的IO流中,当打开了一个关联文件的资源,最后程序不管结果如何,都需要把这个资源关闭掉。

try catch 语句中有return 的各类情况

首先给出一道题目:

下面代码的运行结果为?

public class test {
	public int add(int a,int b) {
		try {
			return a+b;
		}catch(Exception e){
			System.out.println("catch语句块");
		}finally {
			System.out.println("finally语句块");
		}
		return 0;
	}
	public static void main(String[] args) {
		test t=new test();
		System.out.println("和是"+t.add(9, 34));
	}
 
}

A、catch语句块 和是43

B、编译异常

C、finally语句块 和是43

D、和是43 finally语句块

正确答案:C

由于学习过编译原理的课程,知道了System.out.println中要执行add()方法与前面的“和是”字符串拼接后才会输出,因此首先执行add()方法。

add()方法中try语句块中有return语句,那么是否执行完try语句块就直接退出方法了呢?

上述代码在Eclipse下运行此代码结果为:

看来尽管try语句块中有return,还是会执行finally语句块。

看到了合理的解释是,在try中执行到return语句时,不会真正的return,即只是会计算return中的表达式(本题为执行a+b),之后将结果保存在一个临时栈中,接着执行finally中的语句,最后才会从临时栈中取出之前的结果返回。

下面我们在这道题的finally语句中加入这么一行代码:

a=1;

public class test {
	public int add(int a,int b) {
		try {
			return a+b;
		}catch(Exception e){
			System.out.println("catch语句块");
		}finally {
			System.out.println("finally语句块");
			a=1;
		}
		return 0;
	}
	public static void main(String[] args) {
		test t=new test();
		System.out.println("和是"+t.add(9, 34));
	}
 
}

下面是运行结果截图:

从结果看出来结果并没有发生改变,这也验证了finally中的语句不会影响到临时栈中的值,即在执行finally之前,临时栈中的值已经确定为43了,执行finally语句将a的值变为1,对结果没有产生影响,执行完finally后的输出结果仍为43.

finally块中的内容会先于try中的return语句执行,如果finall语句块中也有return语句的话,那么直接从finally中返回了,这也是不建议在finally中return的原因。下面来看这几种情况。

情况一(try中有return,finally中没有return):

public class TryTest{
	public static void main(String[] args){
		System.out.println(test());
	}
private static int test(){
	int num = 10;
	try{
		System.out.println("try");
		return num += 80;
	}catch(Exception e){
		System.out.println("error");
	}finally{
		if (num > 20){
			System.out.println("num>20 : " + num);
		}
		System.out.println("finally");
	}
	return num;
 }
}

输出结果如下:

try
num>20 : 90
finally
90

分析:显然“return num += 80”被拆分成了“num = num+80”和“return num”两个语句,线执行try中的“num = num+80”语句,将其保存起来,在try中的”return num“执行前,先将finally中的语句执行完,而后再将90返回。

情况二(try和finally中均有return):

public class TryTest{
	public static void main(String[] args){
		System.out.println(test());
	}
private static int test(){
	int num = 10;
	try{
		System.out.println("try");
		return num += 80;
	}catch(Exception e){
		System.out.println("error");
	}finally{
		if (num > 20){
			System.out.println("num>20 : " + num);
		}
		System.out.println("finally");
		num = 100;
		return num;
	}
}
}

输出结果如下:

try
num>20 : 90
finally
100

分析:try中的return语句同样被拆分了,finally中的return语句先于try中的return语句执行,因而try中的return被”覆盖“掉了,不再执行。

情况三(finally中改变返回值num):

public class TryTest{
	public static void main(String[] args){
		System.out.println(test());
	}
private static int test(){
	int num = 10;
	try{
		System.out.println("try");
		return num;
	}catch(Exception e){
		System.out.println("error");
	}finally{
		if (num > 20){
			System.out.println("num>20 : " + num);
		}
		System.out.println("finally");
		num = 100;
	}
	return num;
}
}

输出结果如下:

try

finally

10

分析:虽然在finally中改变了返回值num,但因为finally中没有return该num的值,因此在执行完finally中的语句后,test()函数会得到try中返回的num的值,而try中的num的值依然是程序进入finally代码块前保留下来的值,因此得到的返回值为10。

​但是我们来看下面的情况(将num的值包装在Num类中):

public class TryTest{
	public static void main(String[] args){
		System.out.println(test().num);
	}
private static Num test(){
	Num number = new Num();
	try{
		System.out.println("try");
		return number;
	}catch(Exception e){
		System.out.println("error");
	}finally{
		if (number.num > 20){
			System.out.println("number.num>20 : " + number.num);
		}
		System.out.println("finally");
		number.num = 100;
	}
	return number;
}
}
class Num{
	public int num = 10;
}

输出结果如下:

try
finally
100

从结果中可以看出,同样是在finally中改变了返回值num的值,在情况三中,并没有被try中的return返回(test()方法得到的不是100),但在这里却被try中的return语句返回了。

对以上情况的分析,需要深入JVM虚拟机中程序执行exection_table中的字节码指令时操作栈的的操作情况,可以参考htp://www.jb51.net/kf/201010/76754.html)这篇文章,也可以参考《深入Java虚拟机:JVM高级特性与最佳实践》第6章中对属性表集合的讲解部分。

对于含有return语句的情况,这里我们可以简单地总结如下:

       try语句在返回前,将其他所有的操作执行完,保留好要返回的值,而后转入执行finally中的语句,而后分为以下三种情况:

  • 情况一:如果finally中有return语句,则会将try中的return语句”覆盖“掉,直接执行finally中的return语句,得到返回值,这样便无法得到try之前保留好的返回值。
  • 情况二:如果finally中没有return语句,也没有改变要返回值,则执行完finally中的语句后,会接着执行try中的return语句,返回之前保留的值。
  • 情况三:如果finally中没有return语句,但是改变了要返回的值,这里有点类似与引用传递和值传递的区别,分以下两种情况,:

1)如果return的数据是基本数据类型或文本字符串,则在finally中对该基本数据的改变不起作用,try中的return语句依然会返回进入finally块之前保留的值。

2)如果return的数据是引用数据类型,而在finally中对该引用数据类型的属性值的改变起作用,try中的return语句返回的就是在finally中改变后的该属性的值。

异常注意事项

多个异常使用捕获又该如何处理呢?

1.多个异常分别处理。

2.多个异常一次捕获,多次处理。

3.多个异常一次捕获一次处理。

一般我们是使用一次捕获多次处理方式,格式如下:

try{
    //编写可能出现异常的代码
}catch(异常类型A e){//当try中出现A类型异常,就用该catch来捕获
    //处理异常的代码
    //记录日志/打印异常信息/继续抛出异常
}catch(异常类型B e){//当try中出现B类型异常,就用该catch来捕获
    //处理异常的代码//记录日志/打印异常信息/继续抛出异常
}

注意:这种异常处理方式,要求多个catch中的异常不能相同,并且若catch中的多个异常之间有子父类异常的关系,那么子类异常要求在上面的catch处理,父类异常在下面的catch处理。

运行时异常被抛出可以不处理。即不捕获也不声明抛出。

如果finally有return语句,永远返回finally中的结果,避免该情况。

如果父类抛出了多个异常,子类重写父类方法时,抛出和父类相同的异常或者是父类异常的子类或者不抛出异常

父类方法没有抛出异常,子类重写父类该方法时也不可抛出异常。此时子类产生该异常,只能捕获处理,不能声明抛出。

自定义异常

概述

为什么需要自定义异常类:

我们说了Java中不同的异常类,分别表示着某一种具体的异常情况,那么在开发中总是有些异常情况是SUN没有定义好的,此时我们根据自己业务的异常情况来定义异常类。例如年龄负数问题,考试成绩负数问题等等。

在上述代码中,发现这些异常都是JDK内部定义好的,但是实际开发中也会出现很多异常,这些异常很可能在JDK中没有定义过,例如年龄负数问题,考试成绩负数问题.那么能不能自己定义异常呢?

在开发中根据自己业务的异常情况来定义异常类.比如:自定义一个业务逻辑异常:RegisterException。一个注册异常类。

异常类如何定义:

1.自定义一个编译期异常:自定义类并继承于java.lang.Exception。

2.自定义一个运行时期的异常类:自定义类并继承于java.lang.RuntimeException。

自定义异常演示

要求:我们模拟注册操作,如果用户名已存在,则抛出异常并提示:亲,该用户名已经被注册。

首先定义一个注册异常类RegisterException:

public class RegisterException extends Exception{
    /** 
    *空参构造
    */
    public RegisterException (){   
    }
    /**
    *
    *@parammessage异常提示*/
    public RegisterException(String message){
        super (message);
    }
}

模拟登陆操作,使用数组模拟数据库中存储的数据,并提供当前注册账号是否存在方法用于判断。

public class Demo {
    private static String[]names={"lyan","zhyuqi","xdongdong"};
    public static void main(String[]args) {
        try{
            //可能出现异常的代码
            checkUsername("zhyuqi");
            System.out.println("用户名可用!");//没有异常则用户名没有重复,可用
        }catch(RegisterException e){
            //处理异常
            e.printStackTrace();
        }
    }
    //因为RegisterException是编译期异常,又想调用者去处理,所以在方法上声明该异常
  public static boolean checkUsername(String uname) throws RegisterException{for(Stringname:names){
      if(name.equals(uname)){//如果名字在数组里面就抛出注册异常
          throw new RegisterException("亲"+uname+"已经被注册了!");
       }
     }
     return true;
  }
}

到此这篇关于全面了解java异常的文章就介绍到这了,更多相关java异常内容请搜索脚本之家以前的文章或继续浏览下面的相关文章希望大家以后多多支持脚本之家!

你可能感兴趣的